Index: moodle/grade/report/grader/module.js
--- moodle/grade/report/grader/module.js No Base Revision
+++ moodle/grade/report/grader/module.js Locally New
@@ -0,0 +1,1136 @@
+/**
+ * Grader Report Module
+ */
+YUI.add('gradereport_grader', function(Y) {
+    /**
+     * The core namespace for the grader report JavaScript
+     * @namespace M.gradereport_grader
+     */
+    M.gradereport_grader = {
+        table : null,           // YUI Node for the reports main table
+        items : [],             // Array containing grade items
+        users : [],             // Array containing user information
+        feedback : [],          // Array containing feedback items
+        ajaxenabled : false,    // True is AJAX is enabled for the report
+        /**
+         * Initialises the JavaScript for the gradebook grader report
+         * 
+         * @function M.gradereport_grader.init
+         * @this {M.gradereport_grader}
+         * @param {YUI} Y A YUI3 instance
+         * @param {Object} cfg Configuration variables
+         * @param {Array} items An array containing grade items
+         * @param {Array} users An array containing user infomation
+         * @param {Array} feedback An array containing feedback information
+         */
+        init : function(Y, cfg, items, users, feedback) {
+            this.isediting = (cfg.isediting);
+            this.ajaxenabled = (cfg.ajaxenabled);
+            this.items = items;
+            this.users = users;
+            this.feedback = feedback;
+            this.table = Y.one('#user-grades');
+
+            // Initalise tooltips
+            this.tooltip.init();
+            
+            // Alias this so that we can use the correct scope in the coming
+            // node iteration
+            this.table.all('tr').each(function(tr){
+                // Check it is a user row
+                if (tr.getAttribute('id').match(/^fixed_user_(\d+)$/)) {
+                    // Highlight rows
+                    tr.all('th.cell').on('click', this.table_highlight_row, this, tr);
+                    // Display tooltips
+                    tr.all('td.cell').each(function(cell){
+                        this.tooltip.attach(cell);
+                    }, this);
+                }
+            }, this);
+
+            // If the fixed table exists then map those rows to highlight the
+            // grades table rows
+            var fixed = Y.one('#fixed_column');
+            if (fixed) {
+                fixed.all('tr').each(function(tr) {
+                    if (tr.getAttribute('id').match(/^fixed_user_(\d+)$/)) {
+                        tr.all('th.cell').on('click', this.table_highlight_row, this, Y.one(tr.getAttribute('id').replace(/^fixed_/, '#')));
+                    }
+                }, this)
+            }
+
+            // Highlight columns
+            this.table.all('.highlightable').each(function(cell){
+                cell.on('click', this.table_highlight_column, this, cell);
+                cell.removeClass('highlightable');
+            }, this);
+
+            // If ajax is enabled then initialise the ajax component
+            if (this.ajaxenabled) {
+                this.ajax.init(cfg);
+            }
+        },
+        /**
+         * Highlights a row in the report
+         *
+         * @function M.gradereport_grader.table_highlight_row
+         * @param {Event} e
+         * @param {Y.Node} tr The table row to hightlight
+         */
+        table_highlight_row : function (e, tr) {
+            tr.all('.cell').toggleClass('hmarked');
+        },
+        /**
+         * Highlights a cell in the table
+         *
+         * @function M.gradereport_grader.table_highlight_column
+         * @param {Event} e
+         * @param {Y.Node} cell
+         */
+        table_highlight_column : function(e, cell) {
+            var column = 0;
+            while (cell = cell.previous('.cell')) {
+                column += parseFloat(cell.getAttribute('colspan')) || 1;
+            }
+            this.table.all('.c'+column).toggleClass('vmarked');
+        },
+        /**
+         * Builds an object containing information at the relevant cell given either
+         * the cell to get information for or an array containing userid and itemid
+         *
+         * @function M.gradereport_grader.get_cell_info
+         * @this {M.gradereport_grader}
+         * @param {Y.Node|Array} arg Either a YUI Node instance or an array containing
+         *                           the userid and itemid to reference
+         * @return {Object}
+         */
+        get_cell_info : function(arg) {
+
+            var userid= null;
+            var itemid = null;
+            var feedback = null;
+            var cell = null;
+            var i = null;
+
+            if (arg instanceof Y.Node) {
+                if (arg.get('nodeName').toUpperCase() !== 'TD') {
+                    arg = arg.ancestor('td.cell');
+                }
+                var regexp = /^u(\d+)i(\d+)$/;
+                var parts = regexp.exec(arg.getAttribute('id'));
+                userid = parts[1];
+                itemid = parts[2];
+                cell = arg;
+            } else {
+                userid = arg[0];
+                itemid = arg[1];
+                cell = Y.one('#u'+userid+'i'+itemid);
+            }
+
+            if (!cell) {
+                return null;
+            }
+
+            for (i in this.feedback) {
+                var f = this.feedback[i];
+                if (f.user == userid && f.item == itemid) {
+                    feedback = f.content;
+                    break;
+                }
+            }
+
+            return {
+                userid : userid,
+                username : this.users[userid],
+                itemid : itemid,
+                itemname : this.items[itemid].name,
+                itemtype : this.items[itemid].type,
+                itemscale : this.items[itemid].scale,
+                itemdp : this.items[itemid].decimals,
+                feedback : feedback,
+                cell : cell
+            };
+        },
+        /**
+         * Updates or creates the feedback JS structure for the given user/item
+         *
+         * @function M.gradereport_grader.update_feedback
+         * @this {M.gradereport_grader}
+         * @param {Int} userid
+         * @param {Int} itemid
+         * @param {String} newfeedback
+         * @return {Bool}
+         */
+        update_feedback : function(userid, itemid, newfeedback) {
+            for (var i in this.feedback) {
+                if (this.feedback[i].user == userid && this.feedback[i].item == itemid) {
+                    this.feedback[i].content = newfeedback;
+                    return true;
+                }
+            }
+            this.feedback.push({user:userid,item:itemid,content:newfeedback});
+            return true;
+        }
+    };
+    /**
+     * Namespace that contains the functions required to deal with the tooltips.
+     * This is a namespace rather than an object so that we can reuse the overlay
+     * and manage the tooltips though a single easy to understand interface.
+     * @namespace
+     */
+    M.gradereport_grader.tooltip = {
+        overlay : null, // Y.Overlay instance
+        /**
+         * Initialises the tooltip by creating the overlay
+         * 
+         * @function M.gradereport_grader.tooltip.init
+         * @this {M.gradereport_grader.tooltip}
+         */
+        init : function() {
+            this.overlay = new Y.Overlay({
+                bodyContent : 'Loading',
+                visible : false,
+                zIndex : 2
+            });
+            this.overlay.render(M.gradereport_grader.table.ancestor('div'));
+        },
+        /**
+         * Attaches the tooltip event to the provided cell
+         *
+         * @function M.gradereport_grader.tooltip.attach
+         * @this M.gradereport_grader
+         * @param {Y.Node} td The cell to attach the tooltip event to
+         */
+        attach : function(td) {
+            td.on('mouseenter', this.show, this);
+        },
+        /**
+         * Shows the tooltip: Callback from @see M.gradereport_grader.tooltip#attach
+         *
+         * @function M.gradereport_grader.tooltip.show
+         * @this {M.gradereport_grader.tooltip}
+         * @param {Event} e
+         */
+        show : function(e) {
+            e.halt();
+
+            var properties = M.gradereport_grader.get_cell_info(e.target);
+            if (!properties) {
+                return;
+            }
+
+            var content  = '<div class="fullname">'+properties.username+'</div>';
+            content += '<div class="itemname">'+properties.itemname+'</div>';
+            if (properties.feedback) {
+                content += '<div class="feedback">'+properties.feedback+'</div>';
+            }
+
+            properties.cell.on('mouseleave', this.hide, this, properties.cell);
+            properties.cell.addClass('tooltipactive');
+            this.overlay.set('xy', [e.target.getX()+(e.target.get('offsetWidth')/2),e.target.getY()+e.target.get('offsetHeight')-5]);
+            this.overlay.set("bodyContent", content);
+            this.overlay.show();
+            this.overlay.get('boundingBox').setStyle('visibility', 'visible');
+        },
+        /**
+         * Hides the tooltip
+         *
+         * @function M.gradereport_grader.tooltip.hide
+         * @this {M.gradereport_grader.tooltip}
+         * @param {Event} e
+         * @param {Y.Node} cell
+         */
+        hide : function(e, cell) {
+            cell.removeClass('tooltipactive');
+            this.overlay.hide();
+            this.overlay.get('boundingBox').setStyle('visibility', 'hidden');
+        }
+    }
+    /**
+     * Namespace that contains all of the AJAX functionality for the grader report
+     * @namespace M.gradereport_grader.ajax
+     */
+    M.gradereport_grader.ajax = {
+        courseid : null,                // The id for the course being viewed
+        feedbacktrunclength : null,     // The length to truncate feedback to
+        studentsperpage : null,         // The number of students shown per page
+        showquickfeedback : null,       // True if feedback editing should be shown
+        current : null,                 // The field being currently editing
+        pendingsubmissions : [],        // Array containing pending IO transactions
+        scales : [],                    // An array of scales used in this report
+        /**
+         * Initalises the AJAX component of this report
+         * @function M.gradereport_grader.ajax.init
+         * @this {M.gradereport_grader.ajax}
+         * @param {Object} cfg
+         */
+        init : function(cfg) {
+            this.courseid = cfg.courseid || null;
+            this.feedbacktrunclength = cfg.courseid || null;
+            this.studentsperpage = cfg.studentsperpage || null;
+            this.showquickfeedback = cfg.showquickfeedback || false;
+            this.scales = cfg.scales || null;
+            this.existingfields = [];
+            var table = M.gradereport_grader.table;
+            if (!M.gradereport_grader.isediting) {
+                table.all('.cell.grade').on('makeditable|click', this.make_editable, this);
+            } else {
+                var g = M.gradereport_grader;
+                for (var userid in g.users) {
+                    if (!this.existingfields[userid]) {
+                        this.existingfields[userid] = [];
+                    }
+                    for (var itemid in g.items) {
+                        this.existingfields[userid][itemid] = new this.existingfield(userid, itemid);
+                    }
+                }
+            }
+        },
+        /**
+         * Makes a cell editable
+         * @function M.gradereport_grader.ajax.make_editable
+         * @this {M.gradereport_grader.ajax}
+         */
+        make_editable : function(e) {
+            if (e.halt) {
+                e.halt();
+                var target = e.target;
+            } else {
+                var target = e;
+            }
+            if (target.get('nodeName').toUpperCase() !== 'TD') {
+                target = target.ancestor('td');
+            }
+            Y.detach('click', this.make_editable, target);
+
+            if (this.current) {
+                // Current is already set!
+                this.process_editable_field(target);
+                return;
+            }
+
+            // Sort out the field type
+            var fieldtype = 'text';
+            if (target.hasClass('grade_type_scale')) {
+                fieldtype = 'scale';
+            }
+            // Create the appropriate field widget
+            switch (fieldtype) {
+                case 'scale':
+                    this.current = new this.scalefield(target);
+                    break;
+                case 'text':
+                default:
+                    this.current = new this.textfield(target);
+                    break;
+            }
+            this.current.replace().attach_key_events();
+        },
+        /**
+         * Callback function for the user pressing the enter key on an editable field
+         *
+         * @function M.gradereport_grader.ajax.keypress_enter
+         * @this {M.gradereport_grader.ajax}
+         * @param {Event} e
+         */
+        keypress_enter : function(e) {
+            this.process_editable_field(null);
+        },
+        /**
+         * Callback function for the user pressing Tab or Shift+Tab
+         *
+         * @function M.gradereport_grader.ajax.keypress_tab
+         * @this {M.gradereport_grader.ajax}
+         * @param {Event} e
+         * @param {Bool} ignoreshift If true and shift is pressed then don't exec
+         */
+        keypress_tab : function(e, ignoreshift) {
+            var next = null;
+            if (e.shiftKey) {
+                if (ignoreshift) {
+                    return;
+                }
+                next = this.get_above_cell();
+            } else {
+                next = this.get_below_cell();
+            }
+            this.process_editable_field(next);
+        },
+        /**
+         * Callback function for the user pressing an CTRL + an arrow key
+         * 
+         * @function M.gradereport_grader.ajax.keypress_arrows
+         * @this {M.gradereport_grader.ajax}
+         */
+        keypress_arrows : function(e) {
+            e.preventDefault();
+            var next = null;
+            switch (e.keyCode) {
+                case 37:    // Left
+                    next = this.get_prev_cell();
+                    break;
+                case 38:    // Up
+                    next = this.get_above_cell();
+                    break;
+                case 39:    // Right
+                    next = this.get_next_cell();
+                    break;
+                case 40:    // Down
+                    next = this.get_below_cell();
+                    break;
+            }
+            this.process_editable_field(next);
+        },
+        /**
+         * Processes an editable field an does what ever is required to update it
+         * 
+         * @function M.gradereport_grader.ajax.process_editable_field
+         * @this {M.gradereport_grader.ajax}
+         * @param {Y.Node|null} next The next node to make editable (chaining)
+         */
+        process_editable_field : function(next) {
+            if (this.current.has_changed()) {
+                var properties = M.gradereport_grader.get_cell_info(this.current.node);
+                var values = this.current.commit();
+                this.current.revert();
+                this.submit(properties, values);
+            } else {
+                this.current.revert();
+            }
+            this.current = null;
+            if (next) {
+                this.make_editable(next, null);
+            }
+        },
+        /**
+         * Gets the next cell that is editable (right)
+         * @function M.gradereport_grader.ajax.get_next_cell
+         * @this {M.gradereport_grader.ajax}
+         * @return {Y.Node}
+         */
+        get_next_cell : function(cell) {
+            var n = cell || this.current.node;
+            var next = n.next('td');
+            var tr = null;
+            if (!next && (tr = n.ancestor('tr').next('tr'))) {
+                next = tr.all('.grade').item(0);
+            }
+            if (!next) {
+                next = this.current.node;
+            }
+            return next;
+        },
+        /**
+         * Gets the previous cell that is editable (left)
+         * @function M.gradereport_grader.ajax.get_prev_cell
+         * @this {M.gradereport_grader.ajax}
+         * @return {Y.Node}
+         */
+        get_prev_cell : function(cell) {
+            var n = cell || this.current.node;
+            var next = n.previous('.grade');
+            var tr = null;
+            if (!next && (tr = n.ancestor('tr').previous('tr'))) {
+                var cells = tr.all('.grade');
+                next = cells.item(cells.size()-1);
+            }
+            if (!next) {
+                next = this.current.node;
+            }
+            return next;
+        },
+        /**
+         * Gets the cell above if it is editable (up)
+         * @function M.gradereport_grader.ajax.get_above_cell
+         * @this {M.gradereport_grader.ajax}
+         * @return {Y.Node}
+         */
+        get_above_cell : function(cell) {
+            var n = cell || this.current.node;
+            var tr = n.ancestor('tr').previous('tr');
+            var next = null;
+            if (tr) {
+                var column = 0;
+                var ntemp = n;
+                while (ntemp = ntemp.previous('td.cell')) {
+                    column++;
+                }
+                next = tr.all('td.cell').item(column);
+            }
+            if (!next) {
+                next = this.current.node;
+            }
+            return next;
+        },
+        /**
+         * Gets the cell below if it is editable (down)
+         * @function M.gradereport_grader.ajax.get_below_cell
+         * @this {M.gradereport_grader.ajax}
+         */
+        get_below_cell : function(cell) {
+            var n = cell || this.current.node;
+            var tr = n.ancestor('tr').next('tr');
+            var next = null;
+            if (tr && !tr.hasClass('avg')) {
+                var column = 0;
+                var ntemp = n;
+                while (ntemp = ntemp.previous('td.cell')) {
+                    column++;
+                }
+                next = tr.all('td.cell').item(column);
+            }
+            if (!next) {
+                next = this.current.node;
+            }
+            return next;
+        },
+        /**
+         * Submits changes for update
+         *
+         * @function M.gradereport_grader.ajax.submit
+         * @this {M.gradereport_grader.ajax}
+         * @param {Object} properties Properties of the cell being editied
+         * @param {Object} values Object containing old + new values
+         */
+        submit : function(properties, values) {
+
+            // Stop the IO queue so we can add to it
+            Y.io.queue.stop();
+            // If the grade has changed add an IO transaction to update it to the queue
+            if (values.grade !== values.oldgrade) {
+                this.pendingsubmissions.push({transaction:Y.io.queue(M.cfg.wwwroot+'/grade/report/grader/ajax_callbacks.php', {
+                    method : 'POST',
+                    data : 'id='+this.courseid+'&userid='+properties.userid+'&itemid='+properties.itemid+'&action=update&newvalue='+values.grade+'&type='+properties.itemtype+'&sesskey='+M.cfg.sesskey,
+                    on : {
+                        complete : this.submission_outcome
+                    },
+                    context : this,
+                    arguments : {
+                        properties : properties,
+                        values : values,
+                        type : 'grade'
+                    }
+                }),complete:false,outcome:null});
+            }
+            // If feedback is editable and has changed add to the IO queue for it
+            if (values.editablefeedback && values.feedback !== values.oldfeedback) {
+                this.pendingsubmissions.push({transaction:Y.io.queue(M.cfg.wwwroot+'/grade/report/grader/ajax_callbacks.php', {
+                    method : 'POST',
+                    data : 'id='+this.courseid+'&userid='+properties.userid+'&itemid='+properties.itemid+'&action=update&newvalue='+values.feedback+'&type=feedback&sesskey='+M.cfg.sesskey,
+                    on : {
+                        complete : this.submission_outcome
+                    },
+                    context : this,
+                    arguments : {
+                        properties : properties,
+                        values : values,
+                        type : 'feedback'
+                    }
+                }),complete:false,outcome:null});
+            }
+            // Process the IO queue
+            Y.io.queue.start();
+        },
+        /**
+         * Callback function for IO transaction completions
+         *
+         * Uses a synchronous queue to ensure we maintain some sort of order
+         * 
+         * @function M.gradereport_grader.ajax.submission_outcome
+         * @this {M.gradereport_grader.ajax}
+         */
+        submission_outcome : function(tid, outcome, args) {
+            // Parse the response as JSON
+            try {
+                outcome = Y.JSON.parse(outcome.responseText);
+            } catch(e) {
+                var message = M.str.gradereport_grader.ajaxfailedupdate;
+                message.replace(/\[1\]/, args.type);
+                message.replace(/\[2\]/, M.gradereport_grader.users[args.properties.userid]);
+                this.display_submission_error(message, p.cell);
+                return;
+            }
+
+            // Quick reference for the grader report
+            var g = M.gradereport_grader;
+            // Check the outcome
+            if (outcome.result == 'success') {
+                // Iterate through each row in the result object
+                for (i in outcome.row) {
+                    // alias it, we use it quite a bit
+                    var r = outcome.row[i];
+                    // Get the cell refered to by this result object
+                    var info = g.get_cell_info([r.userid, r.itemid]);
+                    if (!info) {
+                        continue;
+                    }
+                    // Calculate the final grade for the cell
+                    var finalgrade = '';
+                    if (r.scale) {
+                        finalgrade = (r.finalgrade)?this.scales[r.scale][parseFloat(r.finalgrade)-1]:'-';
+                    } else {
+                        finalgrade = (r.finalgrade)?parseFloat(r.finalgrade).toFixed(info.itemdp):'-';
+                    }
+                    if (g.isediting) {
+                        if (args.properties.itemtype == 'scale') {
+                            info.cell.one('#grade_'+r.userid+'_'+r.itemid).all('options').each(function(option){
+                                if (option.get('value') == finalgrade) {
+                                    option.setAttribute('selected', 'selected');
+                                } else {
+                                    option.removeAttribute('selected');
+                                }
+                            });
+                        } else {
+                            info.cell.one('#grade_'+r.userid+'_'+r.itemid).set('value', finalgrade);
+                        }
+                    } else {
+                        // If there is no currently editing field or if this cell is not being currently edited
+                        if (!this.current || info.cell.get('id') != this.current.node.get('id')) {
+                            // Update the value
+                            info.cell.one('.gradevalue').set('innerHTML',finalgrade);
+                        } else if (this.current && info.cell.get('id') == this.current.node.get('id')) {
+                            // If we are here the grade value of the cell currently being edited has changed !!!!!!!!!
+                            // If the user has not actually changed the old value yet we will automatically correct it
+                            // otherwise we will prompt the user to choose to use their value or the new value!
+                            if (!this.current.has_changed() || confirm(M.str.gradereport_grader.ajaxfieldchanged)) {
+                                this.current.set_grade(finalgrade);
+                                this.current.grade.set('value', finalgrade);
+                            }
+                        }
+                    }
+                }
+                // Flag the changed cell as overridden by ajax
+                args.properties.cell.addClass('ajaxoverridden');
+            } else {
+                var p = args.properties;
+                if (args.type == 'grade') {
+                    var oldgrade = args.values.oldgrade;
+                    p.cell.one('.gradevalue').set('innerHTML',oldgrade);
+                } else if (args.type == 'feedback') {
+                    g.update_feedback(p.userid, p.itemid, args.values.oldfeedback);
+                }
+                this.display_submission_error(outcome.message, p.cell);
+            }
+            // Check if all IO transactions in the queue are complete yet
+            var allcomplete = true;
+            for (var i in this.pendingsubmissions) {
+                if (this.pendingsubmissions[i].transaction.id == tid) {
+                    this.pendingsubmissions[i].complete = true;
+                    this.pendingsubmissions[i].outcome = outcome;
+                    Y.io.queue.remove(this.pendingsubmissions[i].transaction);
+                }
+                if (!this.pendingsubmissions[i].complete) {
+                    allcomplete = false;
+                }
+            }
+            if (allcomplete) {
+                this.pendingsubmissions = [];
+            }
+        },
+        /**
+         * Displays a submission error within a overlay on the cell that failed update
+         *
+         * @function M.gradereport_grader.ajax.display_submission_error
+         * @this {M.gradereport_grader.ajax}
+         * @param {String} message
+         * @param {Y.Node} cell
+         */
+        display_submission_error : function(message, cell) {
+            var erroroverlay = new Y.Overlay({
+                headerContent : '<div><strong class="error">'+M.str.gradereport_grader.ajaxerror+'</strong>  <em>'+M.str.gradereport_grader.ajaxclicktoclose+'</em></div>',
+                bodyContent : message,
+                visible : false,
+                zIndex : 3
+            });
+            erroroverlay.set('xy', [cell.getX()+10,cell.getY()+10]);
+            erroroverlay.render(M.gradereport_grader.table.ancestor('div'));
+            erroroverlay.show();
+            erroroverlay.get('boundingBox').on('click', function(){
+                this.get('boundingBox').setStyle('visibility', 'hidden');
+                this.hide();
+                this.destroy();
+            }, erroroverlay);
+            erroroverlay.get('boundingBox').setStyle('visibility', 'visible');
+            // Transparency is COOL!!
+            var makeopace = function(e) {
+                if (this.get) {
+                    if (e.type == 'mouseover') {
+                        this.get('boundingBox').setStyle('opacity', 0.5);
+                    } else {
+                        this.get('boundingBox').setStyle('opacity', 1);
+                    }
+                }
+            }
+            erroroverlay.get('boundingBox').on('mouseenter', makeopace, erroroverlay);
+            erroroverlay.get('boundingBox').on('mouseleave', makeopace, erroroverlay);
+        }
+    };
+    /**
+     * A class for existing fields
+     * This class is used only when the user is in editing mode
+     *
+     * @class
+     * @constructor
+     * @param {Int} userid
+     * @param {Int} itemid
+     */
+    M.gradereport_grader.ajax.existingfield = function(userid, itemid) {
+        this.userid = userid;
+        this.itemid = itemid;
+        this.editfeedback = M.gradereport_grader.ajax.showquickfeedback;
+        this.grade = Y.one('#grade_'+userid+'_'+itemid);
+        this.oldgrade = Y.one('#oldgrade_'+userid+'_'+itemid);
+
+        // On blur save any changes in the grade field
+        this.grade.on('blur', this.submit, this);
+
+        // Check if feedback is enabled
+        if (this.editfeedback) {
+            // Get the feedback fields
+            this.feedback = Y.one('#feedback_'+userid+'_'+itemid);
+            this.oldfeedback = Y.one('#oldfeedback_'+userid+'_'+itemid);
+            // On blur save any changes in the feedback field
+            this.feedback.on('blur', this.submit, this);
+
+            // Override the default tab movements when moving between cells
+            this.keyevents.push(Y.on('key', this.keypress_tab, this.grade, 'press:9+shift', this));                // Handle Shift+Tab
+            this.keyevents.push(Y.on('key', this.keypress_tab, this.feedback, 'press:9', this, true));                   // Handle Tab
+            this.keyevents.push(Y.on('key', this.keypress_enter, this.feedback, 'press:13', this));                // Handle the Enter key being pressed
+            this.keyevents.push(Y.on('key', this.keypress_arrows, this.feedback, 'press:37,38,39,40+ctrl', this)); // Handle CTRL + arrow keys
+
+            // Override the default tab movements for fields in the same cell
+            this.keyevents.push(Y.on('key', function(e){e.preventDefault();this.grade.focus()}, this.feedback, 'press:9+shift', this));
+            this.keyevents.push(Y.on('key', function(e){if (e.shiftKey) return;e.preventDefault();this.feedback.focus()}, this.grade, 'press:9', this));
+        } else {
+            this.keyevents.push(Y.on('key', this.keypress_tab, this.grade, 'press:9', this));                      // Handle Tab and Shift+Tab
+        }
+        this.keyevents.push(Y.on('key', this.keypress_enter, this.grade, 'press:13', this));                   // Handle the Enter key being pressed
+        this.keyevents.push(Y.on('key', this.keypress_arrows, this.grade, 'press:37,38,39,40+ctrl', this));    // Handle CTRL + arrow keys
+    };
+    M.gradereport_grader.ajax.existingfield.prototype.userid = null;
+    M.gradereport_grader.ajax.existingfield.prototype.itemid = null;
+    M.gradereport_grader.ajax.existingfield.prototype.editfeedback = false;
+    M.gradereport_grader.ajax.existingfield.prototype.grade = null;
+    M.gradereport_grader.ajax.existingfield.prototype.oldgrade = null;
+    M.gradereport_grader.ajax.existingfield.prototype.keyevents = [];
+    /**
+     * Handles saving of changed on keypress
+     * 
+     * @function M.gradereport_grader.ajax.existingfield.keypress_enter
+     * @this {M.gradereport_grader.ajax.existingfield}
+     * @param {Event} e
+     */
+    M.gradereport_grader.ajax.existingfield.prototype.keypress_enter = function(e) {
+        this.submit();
+    }
+    /**
+     * Handles setting the correct focus if the user presses tab
+     * 
+     * @function M.gradereport_grader.ajax.existingfield.keypress_tab
+     * @this {M.gradereport_grader.ajax.existingfield}
+     * @param {Event} e
+     * @param {Bool} ignoreshift
+     */
+    M.gradereport_grader.ajax.existingfield.prototype.keypress_tab = function(e, ignoreshift) {
+        e.preventDefault();
+        var next = null;
+        if (e.shiftKey) {
+            if (ignoreshift) {
+                return;
+            }
+            next = M.gradereport_grader.ajax.get_above_cell(this.grade.ancestor('td'));
+        } else {
+            next = M.gradereport_grader.ajax.get_below_cell(this.grade.ancestor('td'));
+        }
+        this.move_focus(next);
+    }
+    /**
+     * Handles setting the correct focus when the user presses CTRL+arrow keys
+     *
+     * @function M.gradereport_grader.ajax.existingfield.keypress_arrows
+     * @this {M.gradereport_grader.ajax.existingfield}
+     * @param {Event} e
+     */
+    M.gradereport_grader.ajax.existingfield.prototype.keypress_arrows = function(e) {
+        var next = null;
+        switch (e.keyCode) {
+            case 37:    // Left
+                next = M.gradereport_grader.ajax.get_prev_cell(this.grade.ancestor('td'));
+                break;
+            case 38:    // Up
+                next = M.gradereport_grader.ajax.get_above_cell(this.grade.ancestor('td'));
+                break;
+            case 39:    // Right
+                next = M.gradereport_grader.ajax.get_next_cell(this.grade.ancestor('td'));
+                break;
+            case 40:    // Down
+                next = M.gradereport_grader.ajax.get_below_cell(this.grade.ancestor('td'));
+                break;
+        }
+        this.move_focus(next);
+    }
+    /**
+     * Move the focus to the node
+     * @function M.gradereport_grader.ajax.existingfield.move_focus
+     * @this {M.gradereport_grader.ajax.existingfield}
+     * @param {Y.Node} node
+     */
+    M.gradereport_grader.ajax.existingfield.prototype.move_focus = function(node) {
+        if (node) {
+            var properties = M.gradereport_grader.get_cell_info(node);
+            switch(properties.itemtype) {
+                case 'scale':
+                    properties.cell.one('select.select').focus();
+                    break;
+                case 'value':
+                default:
+                    properties.cell.one('input.text').focus();
+                    break;
+            }
+        }
+    }
+    /**
+     * Checks if the values for the field have changed
+     * 
+     * @function M.gradereport_grader.ajax.existingfield.has_changed
+     * @this {M.gradereport_grader.ajax.existingfield}
+     */
+    M.gradereport_grader.ajax.existingfield.prototype.has_changed = function() {
+        if (this.editfeedback) {
+            return (this.grade.get('value') !== this.oldgrade.get('value') || this.feedback.get('value') !== this.oldfeedback.get('value'));
+        }
+        return (this.grade.get('value') !== this.oldgrade.get('value'));
+    }
+    /**
+     * Submits any changes and then updates the fields accordingly
+     *
+     * @function M.gradereport_grader.ajax.existingfield.submit
+     * @this {M.gradereport_grader.ajax.existingfield}
+     */
+    M.gradereport_grader.ajax.existingfield.prototype.submit = function() {
+        if (!this.has_changed()) {
+            return;
+        }
+        var properties = M.gradereport_grader.get_cell_info([this.userid,this.itemid]);
+        var values = (function(f){
+            var feedback, oldfeedback = null;
+            if (f.editfeedback) {
+                feedback = f.feedback.get('value');
+                oldfeedback = f.oldfeedback.get('value');
+            }
+            return {
+                editablefeedback : f.editfeedback,
+                grade : f.grade.get('value'),
+                oldgrade : f.oldgrade.get('value'),
+                feedback : feedback,
+                oldfeedback : oldfeedback
+            }
+        })(this);
+        if (values.editablefeedback && values.feedback != values.oldfeedback) {
+            M.gradereport_grader.update_feedback(this.userid, this.itemid, values.feedback);
+        }
+        M.gradereport_grader.ajax.submit(properties, values);
+    }
+    /**
+     * Class used to make an editable text field for grade values + feedback
+     *
+     * @class textfield
+     * @constructor
+     * @this {M.gradereport_grader.ajax.textfield}
+     * @param {Y.Node}
+     */
+    M.gradereport_grader.ajax.textfield = function(node) {
+        this.node = node;
+        this.gradespan = node.one('.gradevalue'),
+        this.inputdiv = Y.Node.create('<div></div>');
+        this.editfeedback = M.gradereport_grader.ajax.showquickfeedback;
+        this.grade = Y.Node.create('<input type="text" class="text" value="" />');
+        this.gradetype = 'value';
+        this.inputdiv.append(this.grade);
+        if (M.gradereport_grader.ajax.showquickfeedback) {
+            this.feedback = Y.Node.create('<input type="text" class="quickfeedback" value="" />');
+            this.inputdiv.append(this.feedback);
+        }
+    };
+    /**
+     * @property {Array} keyevents
+     */
+    M.gradereport_grader.ajax.textfield.prototype.keyevents = [];
+    /**
+     * @property {Bool} editable
+     */
+    M.gradereport_grader.ajax.textfield.prototype.editable = false;
+    /**
+     * Replaces the cell contents with the controls to enable editing
+     * 
+     * @function M.gradereport_grader.ajax.textfield.replace
+     * @this {M.gradereport_grader.ajax.textfield}
+     */
+    M.gradereport_grader.ajax.textfield.prototype.replace = function() {
+        this.set_grade(this.get_grade());
+        if (this.editfeedback) {
+            this.set_feedback(this.get_feedback());
+        }
+        this.node.replaceChild(this.inputdiv, this.gradespan);
+        this.grade.focus();
+        this.editable = true;
+        return this;
+    }
+    /**
+     * Commits the changes within a cell and returns a result object of new + old values
+     * @function M.gradereport_grader.ajax.textfield.commit
+     * @this {M.gradereport_grader.ajax.textfield}
+     * @return {Object}
+     */
+    M.gradereport_grader.ajax.textfield.prototype.commit = function() {
+        // Produce an anonymous result object contianing all values
+        var result = (function(field){
+            field.editable = false;
+            var oldgrade = field.get_grade();
+            if (oldgrade == '-') {
+                oldgrade = '';
+            }
+            var feedback, oldfeedback = null
+            if (field.editfeedback) {
+                oldfeedback = field.get_feedback();
+            }
+            field.editable = true;
+            if (field.editfeedback) {
+                feedback = field.get_feedback();
+            }
+            return {
+                gradetype : field.gradetype,
+                editablefeedback : field.editfeedback,
+                grade : field.get_grade(),
+                oldgrade : oldgrade,
+                feedback : feedback,
+                oldfeedback : oldfeedback
+            }
+        })(this);
+        // Set the changes in stone
+        this.set_grade(result.grade);
+        if (this.editfeedback) {
+            this.set_feedback(result.feedback);
+        }
+        // Return the result object
+        return result;
+    }
+    /**
+     * Reverts a cell back to its static contents
+     * @function M.gradereport_grader.ajax.textfield.revert
+     * @this {M.gradereport_grader.ajax.textfield}
+     */
+    M.gradereport_grader.ajax.textfield.prototype.revert = function() {
+        this.node.replaceChild(this.gradespan, this.inputdiv);
+        for (var i in this.keyevents) {
+            this.keyevents[i].detach();
+        }
+        this.keyevents = [];
+        this.node.on('makeditable|click', M.gradereport_grader.ajax.make_editable, M.gradereport_grader.ajax);
+    },
+    /**
+     * Gets the grade for current cell
+     * 
+     * @function M.gradereport_grader.ajax.textfield.get_grade
+     * @this {M.gradereport_grader.ajax.textfield}
+     * @return {Mixed}
+     */
+    M.gradereport_grader.ajax.textfield.prototype.get_grade = function() {
+        if (this.editable) {
+            return this.grade.get('value');
+        }
+        return this.gradespan.get('innerHTML');
+    }
+    /**
+     * Sets the grade for the current cell
+     * @function M.gradereport_grader.ajax.textfield.set_grade
+     * @this {M.gradereport_grader.ajax.textfield}
+     * @param {Mixed} value
+     */
+    M.gradereport_grader.ajax.textfield.prototype.set_grade = function(value) {
+        if (!this.editable) {
+            if (value == '-') value = '';
+            this.grade.set('value', value);
+        } else {
+            if (value == '') value = '-';
+            this.gradespan.set('innerHTML', value);
+        }
+    }
+    /**
+     * Gets the feedback for the current cell
+     * @function M.gradereport_grader.ajax.textfield.get_feedback
+     * @this {M.gradereport_grader.ajax.textfield}
+     * @return {String}
+     */
+    M.gradereport_grader.ajax.textfield.prototype.get_feedback = function() {
+        if (this.editable) {
+            return this.feedback.get('value');
+        }
+        var properties = M.gradereport_grader.get_cell_info(this.node);
+        if (properties) {
+            return properties.feedback || '';
+        }
+        return '';
+    }
+    /**
+     * Sets the feedback for the current cell
+     * @function M.gradereport_grader.ajax.textfield.set_feedback
+     * @this {M.gradereport_grader.ajax.textfield}
+     * @param {Mixed} value
+     */
+    M.gradereport_grader.ajax.textfield.prototype.set_feedback = function(value) {
+        if (!this.editable) {
+            this.feedback.set('value', value);
+        } else {
+            var properties = M.gradereport_grader.get_cell_info(this.node);
+            M.gradereport_grader.update_feedback(properties.userid, properties.itemid, value);
+        }
+    }
+    /**
+     * Checks if the current cell has changed at all
+     * @function M.gradereport_grader.ajax.textfield.has_changed
+     * @this {M.gradereport_grader.ajax.textfield}
+     * @return {Bool}
+     */
+    M.gradereport_grader.ajax.textfield.prototype.has_changed = function() {
+        // If its not editable it has not changed
+        if (!this.editable) {
+            return false;
+        }
+        // If feedback is being edited then it has changed if either grade or feedback have changed
+        if (this.editfeedback) {
+            var properties = M.gradereport_grader.get_cell_info(this.node);
+            return (this.get_grade() != this.gradespan.get('innerHTML') || this.get_feedback() != properties.feedback)
+        }
+        return (this.get_grade() != this.gradespan.get('innerHTML'));
+    }
+    /**
+     * Attaches the key listeners for the editable fields and stored the event references
+     * against the textfield
+     * 
+     * @function M.gradereport_grader.ajax.textfield.attach_key_events
+     * @this {M.gradereport_grader.ajax.textfield}
+     */
+    M.gradereport_grader.ajax.textfield.prototype.attach_key_events = function() {
+        var a = M.gradereport_grader.ajax;
+        // Setup the default key events for tab and enter
+        if (this.editfeedback) {
+            this.keyevents.push(Y.on('key', a.keypress_tab, this.grade, 'press:9+shift', a));               // Handle Shift+Tab
+            this.keyevents.push(Y.on('key', a.keypress_tab, this.feedback, 'press:9', a, true));            // Handle Tab
+            this.keyevents.push(Y.on('key', a.keypress_enter, this.feedback, 'press:13', a));               // Handle the Enter key being pressed
+        } else {
+            this.keyevents.push(Y.on('key', a.keypress_tab, this.grade, 'press:9', a));                     // Handle Tab and Shift+Tab
+        }
+        this.keyevents.push(Y.on('key', a.keypress_enter, this.grade, 'press:13', a));                      // Handle the Enter key being pressed
+        // Setup the arrow key events
+        this.keyevents.push(Y.on('key', a.keypress_arrows, this.grade.ancestor('td'), 'down:37,38,39,40+ctrl', a));       // Handle CTRL + arrow keys
+        // Prevent the default key action on all fields for arrow keys on all key events!
+        // Note: this still does not work in FF!!!!!
+        this.keyevents.push(Y.on('key', function(e){e.preventDefault();}, this.grade, 'down:37,38,39,40+ctrl'));
+        this.keyevents.push(Y.on('key', function(e){e.preventDefault();}, this.grade, 'press:37,38,39,40+ctrl'));
+        this.keyevents.push(Y.on('key', function(e){e.preventDefault();}, this.grade, 'up:37,38,39,40+ctrl'));
+    }
+    /**
+     * An editable scale field
+     * @class scalefield
+     * @constructor
+     * @inherits M.gradereport_grader.ajax.textfield
+     * @base M.gradereport_grader.ajax.textfield
+     * @this {M.gradereport_grader.ajax.scalefield}
+     */
+    M.gradereport_grader.ajax.scalefield = function(node) {
+        this.node = node;
+        this.gradespan = node.one('.gradevalue'),
+        this.inputdiv = Y.Node.create('<div></div>');
+        this.editfeedback = M.gradereport_grader.ajax.showquickfeedback;
+        this.grade = Y.Node.create('<select type="text" class="text" /><option value="-1">'+M.str.gradereport_grader.ajaxchoosescale+'</option></select>');
+        this.gradetype = 'scale';
+        this.inputdiv.append(this.grade);
+        if (this.editfeedback) {
+            this.feedback = Y.Node.create('<input type="text" class="quickfeedback" value="" />');
+            this.inputdiv.append(this.feedback);
+        }
+        var properties = M.gradereport_grader.get_cell_info(node);
+        this.scale = M.gradereport_grader.ajax.scales[properties.itemscale];
+        for (var i in this.scale) {
+            this.grade.append(Y.Node.create('<option value="'+(parseFloat(i)+1)+'">'+this.scale[i]+'</option>'));
+        }
+    };
+    /**
+     * @property {Array} scale
+     */
+    M.gradereport_grader.ajax.scalefield.prototype.scale = [];
+    /**
+     * Extend the scalefield with the functions from the textfield
+     */
+    Y.extend(M.gradereport_grader.ajax.scalefield, M.gradereport_grader.ajax.textfield);
+    /**
+     * Overrides the get_grade function so that it can pick up the value from the
+     * scales select box
+     * 
+     * @function M.gradereport_grader.ajax.scalefield.get_grade
+     * @this {M.gradereport_grader.ajax.scalefield}
+     * return {Int} the scale id
+     */
+    M.gradereport_grader.ajax.scalefield.prototype.get_grade = function(){
+        if (this.editable) {
+            // Return the scale value
+            return this.grade.all('option').item(this.grade.get('selectedIndex')).get('value');
+        } else {
+            // Return the scale values id
+            var value = this.gradespan.get('innerHTML');
+            for (var i in this.scale) {
+                if (this.scale[i] == value) {
+                    return parseFloat(i)+1;
+                }
+            }
+            return -1;
+        }
+    }
+    /**
+     * Overrides the set_grade function of textfield so that it can set the scale
+     * within the scale select box
+     * 
+     * @function M.gradereport_grader.ajax.scalefield.set_grade
+     * @this {M.gradereport_grader.ajax.scalefield}
+     */
+    M.gradereport_grader.ajax.scalefield.prototype.set_grade = function(value) {
+        if (!this.editable) {
+            if (value == '-') value = '-1';
+            this.grade.all('option').each(function(node){
+                if (node.get('value') == value) {
+                    node.set('selected', true);
+                }
+            });
+        } else {
+            if (value == '' || value == '-1') {
+                value = '-';
+            } else {
+                value = this.scale[parseFloat(value)-1];
+            }
+            this.gradespan.set('innerHTML', value);
+        }
+    }
+    /**
+     * Checks if the current cell has changed at all
+     * @function M.gradereport_grader.ajax.scalefield.has_changed
+     * @this {M.gradereport_grader.ajax.scalefield}
+     * @return {Bool}
+     */
+    M.gradereport_grader.ajax.scalefield.prototype.has_changed = function() {
+        if (!this.editable) {
+            return false;
+        }
+        var gradef = this.get_grade();
+        this.editable = false;
+        var gradec = this.get_grade();
+        this.editable = true;
+        if (this.editfeedback) {
+            var properties = M.gradereport_grader.get_cell_info(this.node);
+            var feedback = properties.feedback || '';
+            return (gradef != gradec || this.get_feedback() != feedback)
+        }
+        return (gradef != gradec);
+    }
+
+}, '2.0.0', {requires:['base', 'dom', 'event', 'event-mouseenter', 'event-key', 'io', 'json-parse', 'overlay']});
